#include <bits/stdc++.h>

using namespace std;

int main(){
	
	ios_base::sync_with_stdio(false); 
    cin.tie(NULL) ; cout.tie(NULL) ; 
 
	int t;
	cin>>t;
	
	long long int n,m,a1,a2,b1,b2,a=1,b=0,ax,x,min;
	int f;
	int s[t];
	
	for(int i=0;i<t;i++){
		f=1;
		cin>>n>>m;
		cin>>a1;
		for(int j=1;j<n;j++){
			cin>>a2;
			ax=abs(a1-a2);
			a=(j==1?ax:a);
			f*=((a % ax==0)||(ax%a==0)?1:0);
			a=(a<ax?a:ax);
			a1=a2;
			//cout<<f<<"-f1\n";
		}
		
		cin>>b1;
		for(int j=1;j<m;j++){
			cin>>b2;
			x=abs(a1-b1);
			ax=abs(b1-b2);
			f*=(((ax%a)!=0)?1:((x%a !=0)?1:0));
			b1=b2; 
			//cout<<f<<"-f2\n";
		}
		s[i]=f;
		//cout<<i<<"i\n";
	}
	for(int i=0;i<t;i++){
		cout<<s[i]<<"\n";
	}
}